﻿using System;
using System.Data.SqlClient;
namespace db1
{
    class Program
    {
        static string odečti = "Update Účty set Stav = Stav-1000 Where Id = 2";
        static string přičti = "Update Účty set Stav = Stav+1000 Where Id = 4";
        static string kontrola = "select * from Účty where (id = 2) OR (id = 4)";

        static void výpis(string text)
        {
            using(SqlConnection připojení = new SqlConnection(db1.Properties.Settings.Default.připojení))
            {
                připojení.Open();
                SqlCommand příkaz = připojení.CreateCommand();
                příkaz.CommandText = kontrola;
                SqlDataReader rýdr = příkaz.ExecuteReader();
                Console.WriteLine(text);
                while (rýdr.Read())
                {
                    Console.WriteLine(rýdr["ID"].ToString() + ": " + rýdr["Stav"]);
                }

            }
        }

        static void Main(string[] args)
        {
            výpis("Před převodem:");
            Převod();
            výpis("Po převodu:");
        }

        private static void Převod()
        {
            SqlConnection připojení = null;
            SqlTransaction transakce = null;
            try
            {
                připojení = new SqlConnection(db1.Properties.Settings.Default.připojení);
                připojení.Open();
                transakce = připojení.BeginTransaction(System.Data.IsolationLevel.Serializable);
                SqlCommand příkaz = připojení.CreateCommand();
                příkaz.CommandText = odečti;
                příkaz.Transaction = transakce;
                int i = příkaz.ExecuteNonQuery();
                if (i != 1) throw new Exception("Chyba u prvního účtu");
                příkaz.CommandText = přičti;
                i = příkaz.ExecuteNonQuery();
                if (i != 1) throw new Exception("Chyba u druhého účtu");
                transakce.Commit();
            }
            catch (Exception ex)
            {
                System.Console.WriteLine(ex.Message);
                if (transakce != null) transakce.Rollback();
            }
            finally
            {
                if (připojení != null) připojení.Close();
            }
        }

        
    }
}
