﻿using System;
using System.Data.SqlClient;
using System.Data;
using System.IO;

namespace db1
{
    class Program
    {
        static string vložení = "Insert into Účty(ID, Stav) values (@ID, @Stav)";

        static void VložZáznamy(string jménoZdroje)
        {
            using (StreamReader vstup = new StreamReader(jménoZdroje))
            using (SqlConnection připojení = new SqlConnection(db1.Properties.Settings.Default.připojení))
            {
                připojení.Open();
                SqlCommand příkaz = připojení.CreateCommand();
                příkaz.CommandText = vložení;
                while (!vstup.EndOfStream)
                {
                    string řádek = vstup.ReadLine();
                    string[] načtenéParametry = řádek.Split(';');
                    PřipojParametry(načtenéParametry, příkaz);
                    příkaz.ExecuteNonQuery();
                }
            }
        }

        static void Výpis(string text)
        {
            System.Console.WriteLine(text);
            using (SqlConnection připojení = new SqlConnection(db1.Properties.Settings.Default.připojení))
            {
                připojení.Open();
                SqlCommand příkaz = připojení.CreateCommand();
                příkaz.CommandText = "select * from Účty";
                SqlDataReader čteč = příkaz.ExecuteReader();
                while (čteč.Read())
                {
                    System.Console.WriteLine(čteč[0] + ": " + čteč[1]);
                }
            }
        }

        static void PřipojParametry(string[] textParametrů, SqlCommand příkaz)
        {
            příkaz.Parameters.Clear();
            string[] jménoPar = {"ID", "Stav"};
            SqlParameterCollection kolekce = příkaz.Parameters;
            for (int i = 0; i < 2; i++)
            {
                SqlParameter parametr = new SqlParameter(jménoPar[i], Int32.Parse(textParametrů[i].Trim()));
                parametr.DbType = DbType.Int32;
                parametr.SqlDbType = SqlDbType.Int;
                parametr.Direction = ParameterDirection.Input;
                parametr.Size = 4;
                kolekce.Add(parametr);
            }
        }

        static void Main(string[] args)
        {
            try
            {
                Výpis("Před: ");
                VložZáznamy("data.dta");
                Výpis("Po: ");
            }
            catch (Exception ex)
            {
                System.Console.WriteLine(ex.Message);
            }
        }
        
    }
}
