﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DB4
{
    public partial class Okno : Form
    {
        public Okno()
        {
            InitializeComponent();
            připojení = new SqlConnection();
            připojení.ConnectionString = DB4.Properties.Settings.Default.připojení;
            nováTabulka.Columns.Add("Jméno", typeof(string));
            nováTabulka.Columns.Add("Příjmení", typeof(string));
            this.mřížAutoři.DataSource = nováTabulka;
        }

        private void Okno_Load(object sender, EventArgs e)
        {
            try
            {
                SqlDataAdapter adaptérKnih = new SqlDataAdapter(dotazKnih, připojení);
                SqlDataAdapter adaptérAutorů = new SqlDataAdapter(dotazAutora, připojení);
                SqlDataAdapter adaptérAutorství = new SqlDataAdapter(dotazAutorství, připojení);
                připojení.Open();
                adaptérKnih.Fill(data, "Kniha");
                adaptérAutorů.Fill(data, "Autor");
                adaptérAutorství.Fill(data, "Autorství");
                relaceKnihaAutorství = data.Relations.Add(data.Tables["Kniha"].Columns["ID"], data .Tables ["Autorství"].Columns["Id_Knihy"]);
                relaceAutorAutorství = data.Relations.Add(data.Tables["Autor"].Columns["ID"], data .Tables ["Autorství"].Columns["Id_Autora"]);
                tabulka = this.data.Tables["Kniha"];
                this.mřížKnihy.DataSource = tabulka;
                this.mřížKnihy.Columns["Id"].Visible = false;
                //MessageBox.Show("haha");
            }
            finally
            {
                this.připojení.Close();
            }
        }


        private void mřížKnihy_SelectionChanged(object Sender, EventArgs arg)
        {
            if (mřížKnihy.CurrentRow != null)
            {
                int index = mřížKnihy.CurrentRow.Index;
                //int id = (int)tabulka.Rows[index]["ID"];
                DataRow[] řádkyAutorství = tabulka.Rows[index].GetChildRows(relaceKnihaAutorství);
                nováTabulka.Rows.Clear();
                foreach (var řádek in řádkyAutorství)
                {
                    DataRow[] řádkyAutorů = řádek.GetParentRows(relaceAutorAutorství);
                    DataRow novýŘádek = nováTabulka.NewRow();
                    novýŘádek["Jméno"] = řádkyAutorů[0]["Jméno"];
                    novýŘádek["Příjmení"] = řádkyAutorů[0]["Příjmení"];
                    nováTabulka.Rows.Add(novýŘádek);
                }
                
                //this.mřížAutoři.DataSource = nováTabulka;
            }
        }

        private DataSet data = new DataSet();
        private SqlConnection připojení = null;
        private DataTable tabulka = null;
        private DataTable nováTabulka = new DataTable("Nová");
        private DataRelation relaceKnihaAutorství = null;
        private DataRelation relaceAutorAutorství = null;

        private string dotazKnih = "Select Titul, Cena, Id from Kniha";
        private string dotazAutora = "Select * from Autor";
        private string dotazAutorství = "select * from autorství";

    }
}
