﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace dom
{
    public enum Typ {Soukromý, Pracovní};
    
    class Program
    {
        static void Main(string[] args)
        {
            XmlDocument doc = new XmlDocument();
            doc.Load("kontakty.xml");
            //VýpisPříjmeníSoukromýchKontaktů(doc);
            //VýpisJmenATelefonůSoukromýchKontaktůLépe(doc);
            string[] kontakt = { "Pracovní", "Vojtěch", "Peřina", "7654321098" };
            PřidejNovýKontaktZGruntu(doc, kontakt);
        }

        static void PřidejNovýKontakt(XmlDocument doc, string[] kontakt)
        {
            string[] jménoElementu = { "jméno", "příjmení", "telefon" };
            XmlNode novýKontakt = doc.SelectSingleNode("kontakty/kontakt").CloneNode(true);
            novýKontakt.Attributes.GetNamedItem("typ").Value = kontakt[0];
            for(int i = 0; i < jménoElementu.Length; i++)
            {
                novýKontakt.SelectSingleNode(jménoElementu[i]).InnerText = kontakt[i+1];
            }
            doc.SelectSingleNode("kontakty").AppendChild(novýKontakt);
            doc.Save("upravené.xml");
        }

        static void PřidejNovýKontaktZGruntu(XmlDocument doc, string[] kontakt)
        {
            string[] jménoElementu = { "jméno", "příjmení", "telefon" };
            XmlNode novýKontakt = doc.CreateElement("kontakt");
            XmlAttribute atribut = doc.CreateAttribute("typ");
            atribut.Value = kontakt[0];
            novýKontakt.Attributes.Append(atribut);
            for (int i = 0; i < jménoElementu.Length; i++)
            {
                XmlNode fakan = doc.CreateElement(jménoElementu[i]);
                fakan.InnerText = kontakt[i + 1];
                novýKontakt.AppendChild(fakan);
            }
            doc.SelectSingleNode("kontakty").AppendChild(novýKontakt);
            doc.Save("upravené.xml");
        }

        static void VýpisJmenATelefonůSoukromýchKontaktů(XmlDocument doc)
        {
            XmlNodeList seznam = doc.GetElementsByTagName("kontakt");
            foreach (XmlNode kontakt in seznam)
            {
                if (kontakt.Attributes["typ"].Value == "Soukromý")
                {
                    StringBuilder text = new StringBuilder(100);
                    text.Append(kontakt.SelectSingleNode("příjmení").InnerText);
                    text.Append(": ");
                    text.Append(kontakt.SelectSingleNode("telefon").InnerText);
                    System.Console.WriteLine(text.ToString());
                }
            }
        }

        static void VýpisJmenATelefonůSoukromýchKontaktůLépe(XmlDocument doc)
        {
            XmlNodeList seznam = doc.SelectNodes("//kontakt[@typ='Soukromý']");
            foreach (XmlNode kontakt in seznam)
            {
                StringBuilder text = new StringBuilder(100);
                text.Append(kontakt.SelectSingleNode("příjmení").InnerText);
                text.Append(": ");
                text.Append(kontakt.SelectSingleNode("telefon").InnerText);
                System.Console.WriteLine(text.ToString());
            }
        }

        static void VýpisPříjmeníSoukromýchKontaktů(XmlDocument doc)
        {
            XmlNodeList seznam = doc.SelectNodes("//kontakt[@typ='Soukromý']/příjmení");
            foreach (XmlNode kontakt in seznam)
                Console.WriteLine(kontakt.InnerText);
        }
    }
}
