﻿using System;
using System.Collections;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace linqxml
{
    class Program
    {
        static string původníSoubor = "kontakty.xml";
        static string novýSoubor = původníSoubor;
        static void VýpisKontaktůDanéhoTypu(string typ)
        {
            typ = typ.Trim();
            XDocument doc = XDocument.Load(původníSoubor);
            var dotaz = from x in doc.Descendants("kontakt")
                        where x.Attribute("typ").Value.Equals(typ,StringComparison.CurrentCultureIgnoreCase)
                        select x.Element("příjmení").Value + ": " + x.Element("telefon").Value;
            foreach (var s in dotaz)
                System.Console.WriteLine(s);
        }

        static void VypišKontaktyDanéhoTypuDoXml(string typ)
        {
            typ = typ.Trim();
            XDocument zdroj = XDocument.Load(původníSoubor);
            XDocument cíl = new XDocument(
                new XElement("kontakty",
                    from element in zdroj.Root.Elements()
                    where element.Attribute("typ").Value.Equals(typ, StringComparison.CurrentCultureIgnoreCase)
                    select element
                )
            );
            novýSoubor = typ + původníSoubor;
            cíl.Save(novýSoubor);
        }

        static void Main(string[] args)
        {
            //VýpisKontaktůDanéhoTypu("Pracovní");
            VypišKontaktyDanéhoTypuDoXml("pracovní");
        }
    }
}
