using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace let
{
    public class Kontakt
    {
        public string Jmno { set; get; }
        public string Pjmen { set; get; }
        public int RokSeznmen { set; get; }
        public Kontakt(string jmno, string pjmen, int rok)
        {
            Jmno = jmno;
            Pjmen = pjmen;
            RokSeznmen = rok;
        }
        public override string ToString()
        {
            return Jmno + " " + Pjmen + " (" + RokSeznmen + ")";
        }
    }

    class SkupinyPodleDesetilet : IEqualityComparer<int>
    {

        public bool Equals(int x, int y)
        {
            return GetHashCode (x) == GetHashCode(y);
        }

        public int GetHashCode(int x)
        {
            return (x / 10) * 10;
        }
    }

    class Program
    {
        static Kontakt[] kontakty = {
                                        new Kontakt ("Jan", "Novk", 1999),
                                        new Kontakt ("Karel", "Novotn", 2006),
                                        new Kontakt ("Ivan", "Prochzka", 2007),
                                        new Kontakt ("Jan", "Novk", 2009),
                                        new Kontakt ("Ladislav", "Novk", 1998),
                                        new Kontakt ("Jaroslav", "Novk", 1980)
                                    };


        public static void VypiKontaktyPodleDesetilet()
        {
            var dotaz = from skupina in
                            (from kontakt in kontakty
                             group kontakt by (kontakt.RokSeznmen / 10) * 10)
                        orderby skupina.Key
                        select skupina;
                            
      
            foreach (var skupina in dotaz)
            {
                Console.WriteLine(skupina.Key);
                foreach (Kontakt kontakt in skupina)
                    Console.WriteLine(kontakt);
            }
        }

        static void Pomoc()
        {
            var dotaz = from kontakt in kontakty
                        group kontakt by kontakt.RokSeznmen into skupiny
                        from kon in skupiny 
                        select kon;
        }
        
        static void Main(string[] args)
        {
            VypiKontaktyPodleDesetilet();
        }
    }
}
